''
'' Timing test
''

CON
  _clkmode = xtal1 + pll16x
  _clkfreq = 80_000_000

OBJ
  fds : "SimpleSerial.spin"

PUB run | i,x,now,elapsed

  '' start up the serial port
  fds.start(31, 30, 0, 115200)

  '' and say hello
  fds.str(string("timing test", 13, 10))
  pause(4)

  repeat i from 0 to 20
    now := cnt
''    x := fibo(i)
    x := mytest(i+500, i+300, i+200)
    elapsed := cnt - now
    fds.str(string("test("))
    fds.dec(i)
    fds.str(string(") = "))
    fds.dec(x)
    fds.str(string("  time taken: "))
    fds.dec(elapsed)
    fds.str(string(" cycles ("))
    fds.dec(elapsed/80000)
    fds.str(string(" ms)", 13, 10))

  '' now just hang
  fds.str(string("done", 13, 10))
  repeat

PUB fibo(x)
  if (x < 2)
    return x
  return fibo(x-1) + fibo(x-2)

PUB sqr(x) | r, q
  r := x*x
  return r

PUB mytest(seed, u32a, u32b) | u32c, u32x, u32y, low, high
    u32c := seed - 256
    '' want:u32x := u32a * u32b / u32c
    ''      u32y := u32a * u32b // u32c
    asm
      qmul u32a, u32b
      getqx low
      getqy high
      setq  high
      qdiv  low, u32c
      getqx u32x
      getqy u32y
    endasm
    return u32x + u32y

PUB pause(n)
  waitcnt(CNT+n*80000000)
